mysite/blog/urls.py
from django.urls import path
from . import views
from django.contrib.auth import views as auth_views

app_name = 'blog'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path(
        'usuario/novo/', views.NovoUsuarioView.as_view(),
        name='novo_usuario'
    ),
    path(
        'cadastro/',
        views.NovaPostagemView.as_view(), name='nova_postagem'
    ),
    path(
        '<int:postagem>/comenta/',
        views.NovoComentarioView.as_view(), name='novo_comentario'
    ),
    path(
        'arquivo/<int:mes>/',
        views.ArquivoView.as_view(), name='arquivo'
    ),
    path(
        'login/',
        auth_views.LoginView.as_view(template_name='blog/login.html'),
        name = 'login'
    )
]

mysite/index/urls.py
from django.urls import path
from django.views.generic import TemplateView

app_name = 'index'
urlpatterns = [
    path('', TemplateView.as_view(template_name='index/index.html'), name='root'),
]

mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('index.urls')),
    path('enquetes/', include('enquetes.urls')),
    path('blog/', include('blog.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
]

mysite/blog/models.py
from django.db import models
from django.forms import ModelForm
from django.contrib.auth.models import User
from django.forms.widgets import PasswordInput

class UserForm(ModelForm):
    class Meta:
        model = User
        fields = ['username', 'password', 'email', 'first_name', 'last_name']
        widgets = {
            "password":PasswordInput(),
        }

class Postagem(models.Model):
    data = models.DateField()
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    titulo = models.CharField('Título', max_length=100)
    texto = models.TextField()
    def __str__(self):
        return self.titulo

class PostagemForm(ModelForm):
    class Meta:
        model = Postagem
        fields = ['titulo', 'texto']

class Comentario(models.Model):
    data = models.DateField()
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    texto = models.TextField(max_length=200)
    postagem = models.ForeignKey(Postagem, null=True, on_delete=models.CASCADE)
    def __str__(self):
        return self.texto

class ComentarioForm(ModelForm):
    class Meta:
        model = Comentario
        fields = ['texto']

mysite/blog/views.py
from django.utils import timezone
from django.shortcuts import render
from django.urls import reverse
from django.http import HttpResponseRedirect
from django.contrib import messages
from django.views import View
from .models import Postagem, PostagemForm, ComentarioForm, UserForm
from django.utils.decorators import method_decorator
from django.contrib.auth.decorators import login_required
from django.db import connection

class NovoUsuarioView(View):
    def get(self, request, *args, **kwargs):
        form = UserForm()
        contexto = {'form': form}
        return render(request, 'blog/novo_usuario.html', contexto)

class IndexView(View):
    def get(self, request, *args, **kwargs):
        mes_atual = timezone.now().month
        posts = Postagem.objects.filter(data__month = mes_atual).order_by('-id')
        meses = self.get_meses()
        form = ComentarioForm()
        form2 = UserForm()
        contexto = {
            'posts': posts, 'mes': mes_atual, 'meses': meses,
            'form': form, 'form2': form2
        }
        return render(request, 'blog/index.html', contexto)
    def get_meses(self):
        with connection.cursor() as cursor:
            cursor.execute('select distinct data from blog_postagem')
            datas = cursor.fetchall()
        meses = {}
        mes_atual = timezone.now().month
        for d in datas:
            if d[0].month != mes_atual and not d[0].month in meses:
                meses[d[0].month] = d[0].month
        return meses.keys()

class ArquivoView(View):
    def get(self, request, *args, **kwargs):
        mes = kwargs['mes']
        posts = Postagem.objects.filter(data__month = mes).order_by('-id')
        contexto = {'posts': posts, 'mes': mes}
        return render(request, 'blog/arquivo.html', contexto)

@method_decorator(
    login_required(login_url='/blog/login'), name='dispatch'
)
class NovaPostagemView(View):
    def get(self, request, *args, **kwargs):
        form = PostagemForm()
        return render(request, 'blog/novo_post.html', {'form': form})
    def post(self, request, *args, **kwargs):
        form = PostagemForm(request.POST)
        if form.is_valid():
            post = form.save(commit = False)
            post.data = timezone.now()
            post.user = request.user
            post.save()
            messages.success(request, 'Postagem cadastrada com sucesso!')
            return HttpResponseRedirect(reverse('blog:index'))
        else:
            return render(request, 'blog/novo_post.html', {'form': form})

@method_decorator(
    login_required(login_url='/blog/login'), name='dispatch'
)
class NovoComentarioView(View):
    def post(self, request, *args, **kwargs):
        form = ComentarioForm(request.POST)
        if form.is_valid():
            coment = form.save(commit = False)
            coment.data = timezone.now()
            coment.user = request.user
            id_post = kwargs['postagem']
            p = Postagem.objects.get(pk=id_post)
            coment.postagem = p
            coment.save()
            messages.success(request, 'Comentário cadastrado com sucesso!')
        return HttpResponseRedirect(reverse('blog:index'))

mysite/blog/templates/blog/arquivo.html
{% extends 'blog/base.html' %}

{% block principal %}
    <h2>Arquivo de Postagens do Mês {{ mes }}</h2>
    {% if posts %}
        {% for post in posts %}
            <h3>{{ post.titulo }}</h3>
            <p>
            <u>Autor</u>: {{ post.user.first_name }},
            postado em {{ post.data }}.
            </p>
            <p>{{ post.texto | linebreaks }}</p>
            <hr/>
        {% endfor %}
        <hr/>
    {% endif %}
{% endblock %}

mysite/blog/templates/blog/base.html
<html>
    <head>
        <title>Blog App</title>
    </head>
    <body>
        <h1>{% block titulo %}Aplicação de Blog{% endblock %}</h1>
        <hr/>
        {% block menu %}
        <b>Menu:</b>
        <a href="{% url 'blog:index' %}">Home</a>
        | <a href="{% url 'blog:nova_postagem' %}">Nova Postagem</a>
        {% endblock %}
        {% if user.is_authenticated %}
           | Logado como: {{ user.username }}
           (<a href="{% url 'logout' %}?next={% url 'blog:index' %}">logout</a>)
        {% endif %}
        <hr/>
        {% if messages %}
            {% for msg in messages %}
                <p><b>{{ msg }}</b></p>
            {% endfor %}
            <hr/>
        {% endif %}

        {% block principal %}
        {% endblock %}

        <a href="{% url 'index:root' %}">Retorna à aplicalção "index"</a>
    </body>
</html>

mysite/blog/templates/blog/index.html
{% extends 'blog/base.html' %}

{% block principal %}
    <h2>Postagens do Mês {{ mes }}</h2>
    {% if meses %}
        Arquivo de meses anteriores:
        {% for mes in meses %}
            (<a href="{% url 'blog:arquivo' mes %}">{{ mes }}/2022</a>),
        {% endfor %}
    {% endif %}
    {% if posts %}
        {% for post in posts %}
            <h3>{{ post.titulo }}</h3>
            <p>
            <u>Autor</u>: {{ post.user.first_name }},
            postado em {{ post.data }}.
            </p>
            <p>{{ post.texto | linebreaks }}</p>
            {% if post.comentario_set.all %}
              <h4>COMENTÁRIOS:</h4>
              {% for c in post.comentario_set.all %}
                <p>#{{ forloop.counter }} [em {{ c.data|date:'d/m/Y' }},
                por {{ c.user.username }}]: {{ c.texto }}</p>
              {% endfor %}
            {% endif %}
            {% if user.is_authenticated %}
              <h4>Comente aqui...</h4>
              <form action="{% url 'blog:novo_comentario' post.id %}" method="post">
                  {% csrf_token %}
                  {{ form.texto }}<br/>
                  <input type="submit" value="Cadatre seu comentário" />
              </form>
            {% endif %}
            <hr/>
        {% endfor %}
    {% else %}
        <h3>Nenhuma postagem cadastrada nesse mês</h3>
        <hr/>
    {% endif %}
{% endblock %}

mysite/blog/templates/blog/login.html
{% extends 'blog/base.html' %}

{% block principal %}
    <h2>Formulário de Login</h2>
    <form action="{% url 'blog:login' %}" method="post">
        {% csrf_token %}
        <input type="hidden" name="next" value="{{ next }}"/>
        {{ form.as_p }}
        <input type="submit" value="Efetuar Login"/>
    </form>
    <hr/>
    <a href="{% url 'blog:novo_usuario' %}">Clique aqui para fazer o seu cadastro!</a>
    <hr/>
{% endblock %}

mysite/blog/templates/blog/novo_post.html
{% extends 'blog/base.html' %}

{% block principal %}
    <h2>Cadastramento de Postagem</h2>
    <form action="{% url 'blog:nova_postagem' %}" method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="submit" value="Cadastrar Postagem"/>
    </form>
    <hr/>
{% endblock %}

mysite/blog/templates/blog/novo_usuario.html
{% extends 'blog/base.html' %}

{% block principal %}
    <h2>Cadastro de Usuário</h2>
    <form action="{% url 'blog:novo_usuario' %}" method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="submit" value="Realize o seu Cadastro" />
    </form>
{% endblock %}